# PREUD'HOMME Geoffrey
# BEAUSSART Jean-loup
# Donné le 27/01/201question(5)

# TP2 Anagrammes - Dictionnaires

# http://www.fil.univ-lille1.fr/~L1S2API/CoursTP/tp2_dictionnaires.html


def partie(nom):
    print('\n\n\n###', nom, '###')


def section(nom):
    print('\n\n===', nom, '===')


def question(numero):
    print('\n***', 'Question', numero, '***')


partie('Quelques méthodes sur les listes et les chaînes') # Geoffrey

# TODO fonction → méthode

section('Méthode split')

question(1)

# TODO utf-8
# TODO en print

##>>> s = 'la méthode split est parfois bien utile'
##>>> s.split (' ')
##['la', 'm\xc3\xa9thode', 'split', 'est', 'parfois', 'bien', 'utile']
##>>> s.split ('e')
##['la m\xc3\xa9thod', ' split ', 'st parfois bi', 'n util', '']
##>>> s.split ('é')
##['la m', 'thode split est parfois bien utile']
##>>> s.split ()
##['la', 'm\xc3\xa9thode', 'split', 'est', 'parfois', 'bien', 'utile']
##>>> s.split ('')
##Traceback (most recent call last):
##  File "<stdin>", line 1, in <module>
##ValueError: empty separator
##>>> s.split ('split')
##['la m\xc3\xa9thode ', ' est parfois bien utile']

question(2)

# TODO Reformuler

print('La méthode `split` appliquée à une chaîne de caractères renvoie une liste de châines de caractères correspondant à la chaîne de caractère originale découpée aux endroits où se trouvent la chaîne de caractère passée en paramètre (ou si absente, la chaîne de caractère contenant le caractère espacement seul), exemptée de cette dernière.')

question(3)

# TODO utf-8
# TODO en print

##>>> s = "la méthode split est parfois bien utile"
##>>> s.split(' ')
##['la', 'm\xc3\xa9thode', 'split', 'est', 'parfois', 'bien', 'utile']
##>>> s
##'la m\xc3\xa9thode split est parfois bien utile'

print('De par cet exemple, on remarque que s reste la même chaîne de caractère, `split` ne modifie donc pas la chaîne de caractère à laquelle elle s\'applique (ce qui est logique vu le caractère non-mutable des chaînes de caractère')


section('Méthode join')

question(1)

# TODO utf-8
# TODO en print

##>>> l = s.split()
##'lam\xc3\xa9thodesplitestparfoisbienutile'
##>>> " ".join (l)
##'la m\xc3\xa9thode split est parfois bien utile'
##>>> ";".join (l)
##'la;m\xc3\xa9thode;split;est;parfois;bien;utile'
##>>> " tralala ".join (l)
##'la tralala m\xc3\xa9thode tralala split tralala est tralala parfois tralala bien tralala utile'
##>>> print ("\n".join (l))
##la
##méthode
##split
##est
##parfois
##bien
##utile
##>>> "".join (s)
##'la m\xc3\xa9thode split est parfois bien utile'
##>>> "!".join (s)
##'l!a! !m!\xc3!\xa9!t!h!o!d!e! !s!p!l!i!t! !e!s!t! !p!a!r!f!o!i!s! !b!i!e!n! !u!t!i!l!e'
##>>> "".join ()
##Traceback (most recent call last):
##  File "<stdin>", line 1, in <module>
##TypeError: join() takes exactly one argument (0 given)
##>>> "".join ([])
##''
##>>> "".join ([1,2])
##Traceback (most recent call last):
##  File "<stdin>", line 1, in <module>
##TypeError: sequence item 0: expected string, int found

question(2)

print('La méthode join concatène les chaînes de caractères contenues dans la liste passée en paramètre, en insérant entre deux la chaîne de caractère sur laquelle elle est appliquée.')

question(3)

# TODO utf-8
# TODO en print

##>>> chaine = '!'
##>>> chaine.join(l)
##'la!m\xc3\xa9thode!split!est!parfois!bien!utile'
##>>> chaine
##'!'

print('De par cet exemple, on remarque que chaine reste la même chaîne de caractère, `join` ne modifie donc pas la chaîne de caractère à laquelle elle s\'applique (ce qui est logique vu le caractère non-mutable des chaînes de caractère')

question(4)

def join(chaine, sequence):
      # TODO Docstring
      res = ''
      l = len(sequence)
      for i in range(l):
          res += sequence[i]
          if i < l-1:
              res += chaine
      return res

print(">>> join('.', ['raymond', 'calbuth', 'ronchin', 'fr'])")
print(join('.', ['raymond', 'calbuth', 'ronchin', 'fr']))

section('Méthode sort')

question(1)

# TODO utf-8
# TODO en print

##>>> l = list ('timoleon')
##>>> l.sort()
##>>> l
##['e', 'i', 'l', 'm', 'n', 'o', 'o', 't']

print('La méthode sort semble trier les lettres par ordre alphabétique')

##>>> s = "Je n'ai jamais joué de flûte."
##>>> l = list (s)
##>>> l.sort()
##>>> l
##[' ', ' ', ' ', ' ', ' ', "'", '.', 'J', 'a', 'a', 'a', 'd', 'e', 'e', 'e', 'f', 'i', 'i', 'j', 'j', 'l', 'm', 'n', 'o', 's', 't', 'u', '\xa9', '\xbb', '\xc3', '\xc3']

print('La méthode sort trie aussi les caractères spéciaux : ponctuation au début, accents à la fin')

print('Il semblerait que la fonction sort trie les caractères de s selon l\'ordre croissant de leur numéro de code ASCII (ou tout encodage utilisé)')

question(2)

# TODO en print

##>>> l = ['a', 1]
##>>> l.sort()
##>>> l
##[1, 'a']

print('On remarque que 1 se place avant \'a\'. Si nous étions correct dans la question précédente, les éléments de liste sont triés selon leur valeur, ou leur numéro de code pour les caractères. \'a\' ayant pour numéro de code 97 (`ord(\'a\') == 97`), et 1 < 97, il est normal qu\'il se retrouve après le 1.')

section('Une fonction sort pour les chaînes')

question(1)

def sort(chaine):
    # TODO Docstring
    # TODO On peut pas faire plus court ?
    l = list(chaine)
    l.sort()
    return ''.join(l)

print('>>> sort(\'timoleon\')')
print(sort('timoleon'))

partie('Anagrammes') # Jean-loup

question(1)

question(2)

question(3)


section('Casse et accentuation')

question(1)

question(2)

question(3)


partie('Recherche d\'anagrammes') # Jean-loup


section('Le lexique')

question(1)

question(2)

question(3)

question(4)


section('Anagrammes d’un mot : première méthode')

question(1)

question(2)


section('Anagrammes d’un mot : seconde méthode')

question(1)

question(2)

question(3)

question(4)

question(5)


section('Comparaison des deux méthodes')

question(1)


partie('Phrases d\'anagrammes') # Geoffrey

question(1)

